﻿/////////////////////////////////////////////////
//　段間罫線ver1.0
//　http://sysys.blog.shinobi.jp/Entry/27/
/////////////////////////////////////////////////

app.doScript(function(){
var myDocu=app.activeDocument;//線幅
var Sel=myDocu.selection;
if (Sel.length==0) exit();
var Sel0=Sel[0];
if (Sel0.constructor.name!="TextFrame") exit();
var myMeasurementUnit=app.scriptPreferences.measurementUnit;
app.scriptPreferences.measurementUnit=MeasurementUnits.POINTS;
var Keisen0=myDocu.graphicLines.item("keisen"+Sel0.id+"_"+1);
if (Keisen0.isValid){
    var Senhaba=Keisen0.extractLabel("Dankankeisen_Senhaba");
    var Hamidasi=Keisen0.extractLabel("Dankankeisen_Hamidasi");
    var Renketu=Keisen0.extractLabel("Dankankeisen_Renketu")=="true"?true:false;
    var ObjectStyleIndex=Keisen0.appliedObjectStyle.index;
    var LayerIndex=Keisen0.itemLayer.index;
} else {
    var Senhaba="";
    var Hamidasi="";
    var ObjectStyleIndex=0;
    var LayerIndex=Sel0.itemLayer.index;
    var Renketu=false;
}
var myDiag=app.dialogs.add({name:"段間罫線.jsx"});
with (myDiag){
    with (dialogColumns.add()){
        with (dialogRows.add()){
            staticTexts.add({staticLabel:"線幅:"});
            var SenhabaTE=measurementEditboxes.add({editContents:Senhaba,editUnits:myDocu.viewPreferences[app.scriptPreferences.version<7?"lineMeasurementUnits":"strokeMeasurementUnits"]});
        }
        with (dialogRows.add()){
            staticTexts.add({staticLabel:"はみ出し:"});
            var HamidasiTE=measurementEditboxes.add({editContents:Hamidasi,editUnits:myDocu.viewPreferences.horizontalMeasurementUnits});
        }
        with (dialogRows.add()){
            staticTexts.add({staticLabel:"オブジェクトスタイル:"});
            var ObjctStyleDD=dropdowns.add({stringList:myDocu.objectStyles.everyItem().name, selectedIndex:ObjectStyleIndex});
        }
        with (dialogRows.add()){
            staticTexts.add({staticLabel:"レイヤー:"});
            var LayerDD=dropdowns.add({stringList:myDocu.layers.everyItem().name, selectedIndex:LayerIndex});
        }
        var RenketuCC=checkboxControls.add({staticLabel:"連結フレームも",checkedState:Renketu});
        var SakujoCC=checkboxControls.add({staticLabel:"削除だけ",checkedState:false});
    }
}
if(!myDiag.show()) myExit();

(function (myTextFrame) {
    var mySpread=getParentPageOrSpread(myTextFrame)
    var n,Keisen0;
    for (n=1,Keisen0=mySpread.graphicLines.item("keisen"+myTextFrame.id+"_1");Keisen0.isValid;n++,Keisen0=mySpread.graphicLines.item("keisen"+myTextFrame.id+"_"+n)) {
        if (Keisen0.itemLayer.locked){
            Keisen0.itemLayer.locked=false;
            Keisen0.remove();
            Keisen0.itemLayer.locked=true;
        } else {
            Keisen0.remove();
        }
    }
    if (!SakujoCC.checkedState){
        var GB=myTextFrame.geometricBounds;
        var Sotowaku=myTextFrame.strokeAlignment==StrokeAlignment.CENTER_ALIGNMENT?myTextFrame.strokeWeight/2:(myTextFrame.strokeAlignment==StrokeAlignment.INSIDE_ALIGNMENT?myTextFrame.strokeWeight:0)
        var Margin=myTextFrame.textFramePreferences.insetSpacing;
        var Dansuu=myTextFrame.textFramePreferences.textColumnCount;
        var Dankan=myTextFrame.textFramePreferences.textColumnGutter;
        Senhaba=SenhabaTE.editValue;
        Hamidasi=HamidasiTE.editValue;
        if (myTextFrame.parentStory.storyPreferences.storyOrientation==StoryHorizontalOrVertical.HORIZONTAL) {
            var DanW=(GB[3]-GB[1]-Margin[3]-Margin[1]-2*Sotowaku+Dankan)/Dansuu-Dankan;
            var Dan0GB=[GB[0]+Margin[0]+Sotowaku,GB[1]+Margin[1]+Sotowaku,GB[2]-Margin[2]-Sotowaku,GB[1]+Margin[1]+Sotowaku+DanW];
            for (var n=1;n<Dansuu;n++){
                var KeisenGB=[Dan0GB[0]-Hamidasi,Dan0GB[1]+(DanW+Dankan)*n-Dankan/2,Dan0GB[2]+Hamidasi,Dan0GB[1]+(DanW+Dankan)*n-Dankan/2];
                var KeisenName="keisen"+myTextFrame.id+"_"+n;
                var Keisen=mySpread.graphicLines.add({name:KeisenName});
                Keisen.geometricBounds=KeisenGB;
                Keisen.applyObjectStyle(myDocu.objectStyles[ObjctStyleDD.selectedIndex],true);
                if (Senhaba!==0) Keisen.strokeWeight=Senhaba;
                Keisen.move(myDocu.layers[LayerDD.selectedIndex]);
                if (n==1){
                    Keisen.insertLabel("Dankankeisen_Senhaba",""+SenhabaTE.editContents);
                    Keisen.insertLabel("Dankankeisen_Hamidasi",""+HamidasiTE.editContents);
                    Keisen.insertLabel("Dankankeisen_Renketu",""+RenketuCC.checkedState);
                }
            }
        } else {
            var DanH=(GB[2]-GB[0]-Margin[0]-Margin[2]-2*Sotowaku+Dankan)/Dansuu-Dankan;
            var Dan0GB=[GB[0]+Margin[0]+Sotowaku,GB[1]+Margin[1]+Sotowaku,GB[0]+Margin[0]+Sotowaku+DanH,GB[3]-Margin[3]-Sotowaku];
            for (var n=1;n<Dansuu;n++){
                var KeisenGB=[Dan0GB[0]+(DanH+Dankan)*n-Dankan/2,Dan0GB[1]-Hamidasi,Dan0GB[0]+(DanH+Dankan)*n-Dankan/2,Dan0GB[3]+Hamidasi];
                var KeisenName="keisen"+myTextFrame.id+"_"+n;
                var Keisen=mySpread.graphicLines.add({name:KeisenName});
                Keisen.geometricBounds=KeisenGB;
                Keisen.applyObjectStyle(myDocu.objectStyles[ObjctStyleDD.selectedIndex],true);
                if (Senhaba!=0) Keisen.strokeWeight=Senhaba;
                Keisen.move(myDocu.layers[LayerDD.selectedIndex]);
                if (n==1){
                    Keisen.insertLabel("Dankankeisen_Senhaba",""+SenhabaTE.editContents);
                    Keisen.insertLabel("Dankankeisen_Hamidasi",""+HamidasiTE.editContents);
                    Keisen.insertLabel("Dankankeisen_Renketu",""+RenketuCC.checkedState);
                }
            }
        }
    }
    if (RenketuCC.checkedState && myTextFrame.nextTextFrame!=null) arguments.callee(myTextFrame.nextTextFrame);
})(RenketuCC.checkedState?(Sel0.startTextFrame||Sel0):Sel0)
myExit();
function myExit(){
    myDiag.destroy();
    app.scriptPreferences.measurementUnit=myMeasurementUnit;
    exit();
}
function getParentPageOrSpread(Obj){
    return (Obj.constructor.name=="Page"||Obj.constructor.name=="Spread"||Obj.constructor.name=="MasterSpread")?Obj:(Obj.constructor.name=="Application"?null:getParentPageOrSpread(Obj.parent));
}
},ScriptLanguage.JAVASCRIPT,[],UndoModes.ENTIRE_SCRIPT);